package
{
   import caurina.transitions.*;
   import flash.display.*;
   import flash.events.*;
   import flash.text.TextField;
   
   [Embed(source="/_assets/assets.swf", symbol="symbol5")]
   public class TransitionGraphic extends MovieClip
   {
      private static const TRANSITION_TIME:Number = 0.75;
      
      private static const LINE_THICKNESS:Number = 2;
      
      private static const LINE_COLOR:Number = 13311;
      
      private var _lineCanvas:Sprite;
      
      private var _transitionType:String;
      
      public var mcCanvasBG:Sprite;
      
      private var _phase:Number;
      
      private var _height:Number;
      
      private var _transitionEquation:Function;
      
      private var _width:Number;
      
      public var txtTransitionType:TextField;
      
      public function TransitionGraphic(param1:String = "linear", param2:Function = null)
      {
         super();
         _phase = 0;
         _width = 120;
         _height = 97;
         _lineCanvas = new Sprite();
         _lineCanvas.x = 0;
         _lineCanvas.y = mcCanvasBG.y;
         addChild(_lineCanvas);
         swapChildren(_lineCanvas,txtTransitionType);
         transitionType = param1;
         _transitionEquation = param2;
         mcCanvasBG.addEventListener(MouseEvent.MOUSE_DOWN,mouseDown);
         buttonMode = true;
         useHandCursor = true;
      }
      
      public function redraw() : void
      {
         mcCanvasBG.width = _width;
         mcCanvasBG.height = _height - mcCanvasBG.y;
         txtTransitionType.width = _width;
         redrawCurve();
      }
      
      public function showTransition(param1:Number) : void
      {
         phase = 0;
         Tweener.addTween(this,{
            "phase":1,
            "delay":param1,
            "time":TRANSITION_TIME,
            "transition":"linear"
         });
      }
      
      public function get transitionType() : String
      {
         return _transitionType;
      }
      
      public function redrawCurve() : void
      {
         var _loc1_:Number = NaN;
         var _loc2_:Number = NaN;
         var _loc3_:Number = NaN;
         var _loc4_:Number = NaN;
         _lineCanvas.graphics.clear();
         _lineCanvas.graphics.lineStyle(LINE_THICKNESS,LINE_COLOR);
         _loc4_ = 0;
         while(_loc4_ <= _phase)
         {
            _loc2_ = _loc4_ * mcCanvasBG.width;
            _loc1_ = Number(_transitionEquation(_loc4_,0,1,1));
            _loc3_ = (1 - _loc1_) * mcCanvasBG.height;
            if(_loc4_ == 0)
            {
               _lineCanvas.graphics.moveTo(_loc2_ + 0.5,_loc3_ + 0.5);
            }
            else
            {
               _lineCanvas.graphics.lineTo(_loc2_ + 0.5,_loc3_ + 0.5);
            }
            _loc4_ += 0.005;
         }
      }
      
      public function set transitionType(param1:String) : void
      {
         _transitionType = param1;
         txtTransitionType.text = _transitionType;
      }
      
      public function get phase() : Number
      {
         return _phase;
      }
      
      public function setSize(param1:Number, param2:Number) : void
      {
         _width = param1;
         _height = param2;
         redraw();
      }
      
      public function mouseDown(param1:MouseEvent = null) : void
      {
         showTransition(0);
      }
      
      public function set phase(param1:Number) : void
      {
         _phase = param1 < 0 ? 0 : (param1 > 1 ? 1 : param1);
         redrawCurve();
      }
   }
}

